import { Image } from "canvas";
import { Vector } from "..";
import { EntityGridView } from "../../render/Blueprint";
import { BlueprintEntity } from "../blueprint";
import { RenderPassType } from "../pass";
import { SpriteData } from "../sprite";
import { PicturesTypes, PictureTypes } from "./entity-pictures";
export interface RecipeData {
    type: string;
    name: string;
    normal: {
        enabled: boolean;
        ingredients: Array<any>;
        result: string;
    };
    expensive?: {
        enabled: boolean;
        ingredients: Array<any>;
        result: string;
    };
    ingredients?: Array<any>;
}
export interface ItemData {
    type: string;
    subgroup: string;
    order: string;
    icon_size: number;
    name: string;
    stack_size: number;
    icon: string;
    place_result: string;
    flags: Array<string>;
}
declare type SpriteTypes = SpriteData | {
    layers: Array<SpriteData>;
};
declare type AnimationTypes = PicturesTypes;
export interface EntityData {
    name?: string;
    selection_box?: Array<Array<number>>;
    animation?: AnimationTypes;
    animations?: AnimationTypes;
    sprite?: SpriteTypes;
    sprites?: any;
    picture?: PictureTypes;
    pictures?: PicturesTypes;
    layer?: any;
    overlay?: PictureTypes;
    connection_sprites?: PicturesTypes;
    fluid_box: any;
    fluid_boxes: any;
    output_fluid_box: any;
    structure: any;
    type: string;
    heat_buffer: any;
    energy_source: any;
    ending_patch: any;
    circuit_connector_sprites: any;
    circuit_wire_connection_points: any;
    connector_frame_sprites: any;
    belt_vertical: any;
    ending_bottom: any;
    starting_side: any;
    ending_side: any;
    starting_bottom: any;
    ending_top: any;
    belt_horizontal: any;
    starting_top: any;
}
export interface EntitySprite {
    image?: Image;
    key?: string;
}
export declare class Entity {
    readonly entity: EntityData;
    readonly item: ItemData;
    readonly recipe: RecipeData;
    constructor(entity: EntityData, item: ItemData, recipe: RecipeData);
    getTileSize(ent: BlueprintEntity): Vector;
    getSprite(entity: BlueprintEntity, pass: RenderPassType, highRes: boolean | undefined, animationFrame: number | undefined, grid: EntityGridView): Promise<EntitySprite>;
}
export {};
//# sourceMappingURL=entity.d.ts.map