import { BlueprintEntity } from "../models";
export interface Pass {
    name: string;
    subPasses?: Array<Pass>;
}
export declare class Blueprint {
    private readonly file;
    private readonly blueprint;
    private readonly railEntities;
    private readonly normalEntities;
    constructor(file: string);
    render(file: string, frame?: number, debug?: boolean): Promise<{}>;
    private getSize;
    private getEntityTileSize;
    private readBlueprint;
    private entitiesToGrid;
    private isWithinBB;
    private rotateVector;
}
export declare class EntityGridView {
    readonly grid: {
        [key: number]: {
            [key: number]: BlueprintEntity;
        };
    };
    readonly fluids: {
        [key: number]: {
            [key: number]: number;
        };
    };
    readonly heat: {
        [key: number]: {
            [key: number]: number;
        };
    };
    readonly walls: {
        [key: number]: {
            [key: number]: number;
        };
    };
    readonly belts: {
        [key: number]: {
            [key: number]: number;
        };
    };
    private centerX;
    private centerY;
    constructor(grid: {
        [key: number]: {
            [key: number]: BlueprintEntity;
        };
    }, fluids: {
        [key: number]: {
            [key: number]: number;
        };
    }, heat: {
        [key: number]: {
            [key: number]: number;
        };
    }, walls: {
        [key: number]: {
            [key: number]: number;
        };
    }, belts: {
        [key: number]: {
            [key: number]: number;
        };
    });
    getRelative(relativeX: number, relativeY: number): BlueprintEntity | undefined;
    setCenter(centerX: number, centerY: number): void;
}
//# sourceMappingURL=Blueprint.d.ts.map