"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs = __importStar(require("fs"));
const models_1 = require("../models");
let data;
let categoryMapping;
let entities;
function getData() {
    if (!data) {
        data = JSON.parse(fs.readFileSync("factorio/data.json").toString("UTF-8")).raw;
    }
    return data;
}
exports.getData = getData;
function getCategoryMapping() {
    if (!categoryMapping) {
        categoryMapping = {};
        Object.keys(getData()).forEach((category) => {
            if (category === "recipe" || category === "item") {
                return;
            }
            Object.keys(getData()[category]).forEach((tile) => {
                categoryMapping[tile] = category;
            });
        });
    }
    return categoryMapping;
}
exports.getCategoryMapping = getCategoryMapping;
function getEntity(entity) {
    if (!entities) {
        entities = {};
        Object.keys(getCategoryMapping()).forEach((ent) => {
            entities[ent] = new models_1.Entity(getData()[getCategoryMapping()[ent]][ent], getData().item[ent], getData().recipe[ent]);
        });
    }
    return entities[entity];
}
exports.getEntity = getEntity;
//# sourceMappingURL=ItemData.js.map