"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ItemData_1 = require("../ItemData");
const generic_renderer_1 = __importDefault(require("./generic.renderer"));
class AssemblingMachineRenderer extends generic_renderer_1.default {
    renderPass(entity, pass, highRes = false, animationFrame = 0, grid) {
        return __awaiter(this, void 0, void 0, function* () {
            const ent = ItemData_1.getEntity(entity.name);
            if (!ent) {
                throw new Error(`Entity '${entity.name}' doesn't exist!`);
            }
            if (!ent.entity.animation || !("layers" in ent.entity.animation)) {
                throw new Error(`Unable to render ${entity.name}`);
            }
            const layers = ent.entity.animation.layers;
            let source = layers[0];
            if (pass === "SHADOW") {
                source = layers[1];
            }
            return this.loadSprite(source, entity, pass, "", highRes, animationFrame, grid, (canvas, ctx) => {
                return canvas;
            });
        });
    }
    getKey(entity, pass, highRes, animationFrame, grid) {
        return entity.name + "_" + (entity.direction || 0) + "_" + pass + "_" + animationFrame;
    }
}
exports.default = AssemblingMachineRenderer;
//# sourceMappingURL=assembling-machine.renderer.js.map