"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ItemData_1 = require("../ItemData");
const generic_renderer_1 = __importDefault(require("./generic.renderer"));
class PipeToGroundRenderer extends generic_renderer_1.default {
    renderPass(entity, pass, highRes = false, animationFrame = 0, grid) {
        return __awaiter(this, void 0, void 0, function* () {
            const ent = ItemData_1.getEntity(entity.name);
            if (!ent) {
                throw new Error("Entity '" + entity.name + "' doesn't exist!");
            }
            const pictures = ent.entity.pictures;
            if (!pictures || !("left" in pictures)) {
                throw new Error(`Unable to render ${entity.name}`);
            }
            let source = pictures.up;
            const direction = entity.direction || 0;
            switch (direction) {
                default:
                case 0:
                    break;
                case 2:
                    source = pictures.right;
                    break;
                case 4:
                    source = pictures.down;
                    break;
                case 6:
                    source = pictures.left;
                    break;
            }
            // TODO Add caps to ends
            return this.loadSprite(source, entity, pass, direction || 0, highRes, animationFrame, grid);
        });
    }
    getKey(entity, pass, highRes, animationFrame, grid) {
        return entity.name + "_" + (entity.direction || 0) + "_" + (entity.type || "input") + "_" + pass + "_" + animationFrame;
    }
}
exports.default = PipeToGroundRenderer;
//# sourceMappingURL=pipe-to-ground.renderer.js.map