"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const ItemData_1 = require("../ItemData");
const generic_renderer_1 = __importDefault(require("./generic.renderer"));
class UndergroundBeltRenderer extends generic_renderer_1.default {
    renderPass(entity, pass, highRes = false, animationFrame = 0, grid) {
        return __awaiter(this, void 0, void 0, function* () {
            const ent = ItemData_1.getEntity(entity.name);
            if (!ent) {
                throw new Error("Entity '" + entity.name + "' doesn't exist!");
            }
            let source = ent.entity.structure.direction_in.sheet;
            let direction = entity.direction || 2;
            if (entity.type !== "input") {
                source = ent.entity.structure.direction_out.sheet;
                direction = (direction + 4) % 8;
            }
            return this.loadSprite(source, entity, pass, direction || 0, highRes, animationFrame, grid, (canvas, ctx) => {
                // TODO Add belt
            });
        });
    }
    getKey(entity, pass, highRes, animationFrame, grid) {
        return entity.name + "_" + (entity.direction || 0) + "_" + (entity.type || "input") + "_" + pass + "_" + animationFrame;
    }
}
exports.default = UndergroundBeltRenderer;
//# sourceMappingURL=underground-belt.renderer.js.map