"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const pako_1 = __importDefault(require("pako"));
const text_encoding_1 = require("text-encoding");
const utf8Decoder = new text_encoding_1.TextDecoder("utf-8");
const bearings = {
    0: "north",
    2: "east",
    4: "south",
    6: "west",
};
const directions = {
    0: "up",
    2: "right",
    4: "down",
    6: "left",
};
function decodeBlueprint(blueprintString) {
    const versionlessString = blueprintString.substr(1);
    const compressed = Buffer.from(versionlessString, "base64");
    return JSON.parse(utf8Decoder.decode(pako_1.default.inflate(compressed))).blueprint;
}
exports.decodeBlueprint = decodeBlueprint;
function getBearing(direction) {
    return bearings[direction];
}
exports.getBearing = getBearing;
function getDirection(direction) {
    return directions[direction];
}
exports.getDirection = getDirection;
//# sourceMappingURL=blueprint.js.map