"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const canvas_1 = require("canvas");
function loadImage(location) {
    const image = new Image();
    image.src = location;
    return image;
}
exports.loadImage = loadImage;
function imageToCanvas(image) {
    const canvas = canvas_1.createCanvas(image.width, image.height);
    const ctx = canvas.getContext("2d");
    if (!ctx) {
        throw new Error("Unable to create canvas");
    }
    ctx.drawImage(image, 0, 0);
    return canvas;
}
exports.imageToCanvas = imageToCanvas;
function cropCanvas(canvas, x, y, width, height) {
    const resultCanvas = canvas_1.createCanvas(width, height);
    const ctx = resultCanvas.getContext("2d");
    if (!ctx) {
        throw new Error("Unable to create canvas");
    }
    ctx.drawImage(canvas, x, y, width, height, 0, 0, width, height);
    return resultCanvas;
}
exports.cropCanvas = cropCanvas;
//# sourceMappingURL=image.js.map